
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Story_itemsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const story_items = await db.story_items.create(
            {
                id: data.id || undefined,
        
        sort_order: data.sort_order
        ||
        null
            ,
            
        layout: data.layout
        ||
        null
            ,
            
        overlay_text: data.overlay_text
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await story_items.setStory( data.story || null, {
            transaction,
        });
        
        await story_items.setMedia_item( data.media_item || null, {
            transaction,
        });
        
        await story_items.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return story_items;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const story_itemsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                sort_order: item.sort_order
            ||
            null
            ,
            
                layout: item.layout
            ||
            null
            ,
            
                overlay_text: item.overlay_text
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const story_items = await db.story_items.bulkCreate(story_itemsData, { transaction });

        // For each item created, replace relation files
        

        return story_items;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const story_items = await db.story_items.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.sort_order !== undefined) updatePayload.sort_order = data.sort_order;
        
        
        if (data.layout !== undefined) updatePayload.layout = data.layout;
        
        
        if (data.overlay_text !== undefined) updatePayload.overlay_text = data.overlay_text;
        
        
        updatePayload.updatedById = currentUser.id;

        await story_items.update(updatePayload, {transaction});

        
        
        if (data.story !== undefined) {
            await story_items.setStory(
              
              data.story,
              
              { transaction }
            );
        }
        
        if (data.media_item !== undefined) {
            await story_items.setMedia_item(
              
              data.media_item,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await story_items.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return story_items;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const story_items = await db.story_items.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of story_items) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of story_items) {
                await record.destroy({transaction});
            }
        });


        return story_items;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const story_items = await db.story_items.findByPk(id, options);

        await story_items.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await story_items.destroy({
            transaction
        });

        return story_items;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const story_items = await db.story_items.findOne(
            { where },
            { transaction },
        );

        if (!story_items) {
            return story_items;
        }

        const output = story_items.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.story = await story_items.getStory({
            transaction
        });
        
        
        output.media_item = await story_items.getMedia_item({
            transaction
        });
        
        
        output.organizations = await story_items.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.stories,
        as: 'story',
        
        where: filter.story ? {
          [Op.or]: [
            { id: { [Op.in]: filter.story.split('|').map(term => Utils.uuid(term)) } },
            {
              title: {
                [Op.or]: filter.story.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.media_items,
        as: 'media_item',
        
        where: filter.media_item ? {
          [Op.or]: [
            { id: { [Op.in]: filter.media_item.split('|').map(term => Utils.uuid(term)) } },
            {
              title: {
                [Op.or]: filter.media_item.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.overlay_text) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'story_items',
                        'overlay_text',
                        filter.overlay_text,
                    ),
                };
            }
            

            
            

            
            if (filter.sort_orderRange) {
                const [start, end] = filter.sort_orderRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    sort_order: {
                    ...where.sort_order,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    sort_order: {
                    ...where.sort_order,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.layout) {
                where = {
                    ...where,
                layout: filter.layout,
            };
            }
            


      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.story_items.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'story_items',
                        'layout',
                        query,
                    ),
                ],
            };
        }

        const records = await db.story_items.findAll({
            attributes: [ 'id', 'layout' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['layout', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.layout,
        }));
    }

    
};

